 <script language="speedscript">
 /*
 (c) 2000 Innov8 Computer Software. and
    (c) 2000 Lichtenberg Consulting
    All rights reserved.  Permission granted to freely use and
    distribute so long as this notice appears in tact.
 */   
/***********************************
* Program: datapush.p 
* Author : Steven Lichtenberg
* Date   : 08/22/2000
* Concept: Based on datapump.p by Geoff Crawford and Steven Lichtenberg
* Purpose: Modification of DataPump.p to allow for direct html representation of 
*          table data
* Input Parameters: handle to a temp table record and a CSL of display items
* Output Parameters: creates HTML <td> data in the order required
* Tables Used:
* Modified: 08/22/2000 created as an offshoot of DataPump.p
***********************************/
PROCEDURE VisualizeTable.   
    DEFINE INPUT PARAMETER DataTable AS HANDLE NO-UNDO.
    define input parameter dispfield as char   no-undo.
    DEFINE VARIABLE DataTableQuery AS HANDLE NO-UNDO.
    DEFINE VARIABLE isok AS LOGICAL NO-UNDO.

      run output-header.   
      /**** Modify the HTML before the table as appropriate ***/
    </script>
    <body>
        <table>
    <script language="speedscript">
    /* Create a dynamic query using the handle passed in. */
  
    CREATE QUERY DataTableQuery.
    assign
        isok = DataTableQuery:SET-BUFFERS(DataTable) /* assign the buffer to the query */
        isok = DataTableQuery:QUERY-PREPARE("for each " + DataTable:NAME + 
            " no-lock") /* query the entire table */
        isok = DataTableQuery:QUERY-OPEN.  /* open the query */

    /* Run through each record, calling down one level to visualize each record */                                                        
                                                            
    REPEAT:
        
        /* Get the next record.  Leave the Procedure if we're done. */
        
        isok = DataTableQuery:GET-NEXT.
        IF NOT isok THEN RETURN.
        IF DataTableQuery:QUERY-OFF-END THEN RETURN.
               
        /* Visualize the Record */
        {&out} '<tr>'.
        RUN VisualizeRecord (INPUT DataTable,
            input dispfield).
        {&OUT} '</tr>'.                 
    END.
        </table>
   </body>
END. /* Visualize Table */
PROCEDURE VisualizeRecord.

    DEFINE INPUT PARAMETER RecordHandle AS HANDLE NO-UNDO.
    define input parameter displst      as char   no-undo.
                   
    DEFINE VARIABLE DataField AS HANDLE NO-UNDO.
    DEFINE VARIABLE i AS INTEGER NO-UNDO.
        
    
    /* Use the Buffer-Handle to dynamically grab each one of the
       data field handles. Perhaps this could be done more
       efficiently by storing the set of record handles only
       once since the Handles do not change.  However, the
       following is the clearest code. */

    
    DO i = 1 TO num-entries(displst):
        
        DataField = RecordHandle:BUFFER-FIELD(entry(i,displst). 
                /* get the handle by the field number, not name */ 
        
        /* Visualize the Field */            
        RUN VisualizeField (INPUT DataField).
    
    END.
END. /* Visualize Record */
PROCEDURE VisualizeField.

    DEFINE INPUT PARAMETER FieldHandle AS HANDLE NO-UNDO.
    {&out} '<td> '       
        FieldHandle:BUFFER-VALUE
      '</td>' skip.     
END. /* Visualize Field */
