/***************************************************************
* (c) 2000 Lichtenberg Consulting
*   All rights reserved.  Permission granted to freely use and
*   distribute so long as this notice appears in tact.
*
* Program: gettab.p
* Author : Steven Lichtenberg
* Date   : 08-02-2000
* Purpose: Generic routine to create a dynamic temp-table and populate it
*          based on table name and where clause passed into the routine.  This
*          will then pass back the records required of the display/dort routine
*          and will allow for the separation of data access and display
* Tables Used: Any or all
* Modified:
****************************************************************/  
       
/****** Input parameters *********/

DEFINE INPUT  PARAMETER p-table AS CHARACTER  NO-UNDO.
DEFINE INPUT  PARAMETER p-where AS CHARACTER  NO-UNDO.
define    output parameter icnt    as int        no-undo. 
DEFINE OUTPUT PARAMETER table-HANDLE tthnd.



/******** Local Variables ********/
DEFINE VARIABLE h-buff          AS HANDLE     NO-UNDO. /* default buffer handle */
DEFINE VARIABLE h-query         AS HANDLE     NO-UNDO. /* query handle */
DEFINE VARIABLE h-dbtab         AS HANDLE     NO-UNDO. /* table buffer */
def var isok as                 logical       no-undo. /* error processing */
def var v-ttnm                  as char       no-undo. /* temp table name */
def var v-qrystring             as char       no-undo.

{src\web\method\cgidefs.i}


v-qrystring = "for each " + p-table + " " + p-where.

create temp-table tthnd.
v-ttnm = "tt" + p-table.
tthnd:add-fields-from(p-table).  /* define the temp table to be like the table */
tthnd:temp-table-prepare(v-ttnm).
h-buff = tthnd:default-buffer-handle.

create buffer h-dbtab for table p-table.  /* dynamic buffer creation */

create query h-query.
h-query:set-buffers(h-dbtab).     /* assign the buffer to the query */
 /* isok = h-query:query-prepare("for each  " + h-dbtab  + " " +  p-where). */
h-query:query-prepare(v-qrystring). /* assign query string */
h-query:query-open.  /* open the query */
  message "after query open". 
repeat :                                 /* copy table contents to the temp-table */
    h-query:get-next.
    if h-query:query-off-end then
        leave.         
    icnt = icnt + 1.
    h-buff:buffer-create.
    h-buff:buffer-copy(h-dbtab).
end.  /* repeat */
message icnt.
                  /* clean up */

delete object h-dbtab.
delete object h-query.
delete object tthnd.      
return string(icnt).

